"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.name = void 0;
const utils_1 = require("@miniu/utils");
exports.name = 'command';
const plugin = async ({ get }) => {
    get(['command.list'], (list) => {
        const command = process.argv[2] ? process.argv[2].toLowerCase() : '';
        utils_1.postLog({
            action: `MINIU_COMMAND_${command.toUpperCase()}`,
        });
        const printList = [];
        for (let i = 0; i < list.length; i++) {
            if (list[i][0] === command) {
                list[i][2]();
                return;
            }
        }
        if (command === '-v' || command === '--version' || command === 'version') {
            console.log('\nminiu@' + require('miniu/package.json').version);
            return;
        }
        let maxLen = 0;
        list.forEach((item) => {
            maxLen = Math.max(maxLen, item[0].length);
        });
        const getBlanks = (len) => {
            let str = '';
            while (len) {
                len--;
                str += ' ';
            }
            return str;
        };
        list
            .sort((a, b) => (a[0] > b[0] ? 1 : -1))
            .forEach((item) => {
            printList.push(getBlanks(2) + item[0] + getBlanks(maxLen + 6 - item[0].length) + item[1]);
        });
        if (command && command !== '-h' && command !== '--help' && command !== 'help') {
            console.log(`\n"miniu ${command}" Not Found`);
        }
        console.log(`\nUsage: miniu [command]\n\nCommands:\n${printList.join('\n')}`);
    });
};
exports.default = plugin;
